//+------------------------------------------------------------------+
//|                                                        TriMA.mq4 |
//|                               Copyright  2013, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow

extern int Length=20;
extern ENUM_APPLIED_PRICE Price=0; 

double TriMA[];
double MA[];

int N;

int init()
{
 IndicatorShortName("Triangular Moving Average");
 IndicatorBuffers(2);
 IndicatorDigits(Digits);
 SetIndexBuffer(0,TriMA);
 SetIndexBuffer(1,MA);
 
 N=MathCeil((Length+1.)/2.);

 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
 if(Bars<=N) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int pos;
 pos=limit;
 while(pos>=0)
 {
  MA[pos]=iMA(NULL, 0, N, 0, MODE_SMA, Price, pos);
  pos--;
 } 
 
 pos=limit;
 while(pos>=0)
 {
  TriMA[pos]=iMAOnArray(MA, 0, N, 0, MODE_SMA, pos);
  pos--;
 }  
 
 return(0);
}

